package com.hai.dao;

import com.hai.entity.HighUser;
import com.hai.entity.HighUserExample.Criteria;
import com.hai.entity.HighUserExample.Criterion;
import com.hai.entity.HighUserExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighUserSqlProvider {

    public String countByExample(HighUserExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_user");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighUserExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_user");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighUser record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_user");
        
        if (record.getHeaderImg() != null) {
            sql.VALUES("header_img", "#{headerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.VALUES("`name`", "#{name,jdbcType=VARCHAR}");
        }
        
        if (record.getPhone() != null) {
            sql.VALUES("phone", "#{phone,jdbcType=VARCHAR}");
        }
        
        if (record.getPassword() != null) {
            sql.VALUES("`password`", "#{password,jdbcType=VARCHAR}");
        }
        
        if (record.getSex() != null) {
            sql.VALUES("sex", "#{sex,jdbcType=VARCHAR}");
        }
        
        if (record.getBirthdate() != null) {
            sql.VALUES("birthdate", "#{birthdate,jdbcType=DATE}");
        }
        
        if (record.getRegTime() != null) {
            sql.VALUES("reg_time", "#{regTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getGold() != null) {
            sql.VALUES("gold", "#{gold,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpenId() != null) {
            sql.VALUES("open_id", "#{openId,jdbcType=VARCHAR}");
        }
        
        if (record.getOpenIdH5() != null) {
            sql.VALUES("open_id_h5", "#{openIdH5,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionId() != null) {
            sql.VALUES("union_id", "#{unionId,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionOpenId() != null) {
            sql.VALUES("union_open_id", "#{unionOpenId,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionUnionId() != null) {
            sql.VALUES("union_union_id", "#{unionUnionId,jdbcType=VARCHAR}");
        }
        
        if (record.getIsAgent() != null) {
            sql.VALUES("is_agent", "#{isAgent,jdbcType=BIT}");
        }
        
        if (record.getInfoCompleteStatus() != null) {
            sql.VALUES("info_complete_status", "#{infoCompleteStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.VALUES("ext_4", "#{ext4,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighUserExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("header_img");
        sql.SELECT("`name`");
        sql.SELECT("phone");
        sql.SELECT("`password`");
        sql.SELECT("sex");
        sql.SELECT("birthdate");
        sql.SELECT("reg_time");
        sql.SELECT("gold");
        sql.SELECT("`status`");
        sql.SELECT("open_id");
        sql.SELECT("open_id_h5");
        sql.SELECT("union_id");
        sql.SELECT("union_open_id");
        sql.SELECT("union_union_id");
        sql.SELECT("is_agent");
        sql.SELECT("info_complete_status");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("ext_4");
        sql.FROM("high_user");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighUser record = (HighUser) parameter.get("record");
        HighUserExample example = (HighUserExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_user");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getHeaderImg() != null) {
            sql.SET("header_img = #{record.headerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        }
        
        if (record.getPhone() != null) {
            sql.SET("phone = #{record.phone,jdbcType=VARCHAR}");
        }
        
        if (record.getPassword() != null) {
            sql.SET("`password` = #{record.password,jdbcType=VARCHAR}");
        }
        
        if (record.getSex() != null) {
            sql.SET("sex = #{record.sex,jdbcType=VARCHAR}");
        }
        
        if (record.getBirthdate() != null) {
            sql.SET("birthdate = #{record.birthdate,jdbcType=DATE}");
        }
        
        if (record.getRegTime() != null) {
            sql.SET("reg_time = #{record.regTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getGold() != null) {
            sql.SET("gold = #{record.gold,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getOpenId() != null) {
            sql.SET("open_id = #{record.openId,jdbcType=VARCHAR}");
        }
        
        if (record.getOpenIdH5() != null) {
            sql.SET("open_id_h5 = #{record.openIdH5,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionId() != null) {
            sql.SET("union_id = #{record.unionId,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionOpenId() != null) {
            sql.SET("union_open_id = #{record.unionOpenId,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionUnionId() != null) {
            sql.SET("union_union_id = #{record.unionUnionId,jdbcType=VARCHAR}");
        }
        
        if (record.getIsAgent() != null) {
            sql.SET("is_agent = #{record.isAgent,jdbcType=BIT}");
        }
        
        if (record.getInfoCompleteStatus() != null) {
            sql.SET("info_complete_status = #{record.infoCompleteStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_user");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("header_img = #{record.headerImg,jdbcType=VARCHAR}");
        sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        sql.SET("phone = #{record.phone,jdbcType=VARCHAR}");
        sql.SET("`password` = #{record.password,jdbcType=VARCHAR}");
        sql.SET("sex = #{record.sex,jdbcType=VARCHAR}");
        sql.SET("birthdate = #{record.birthdate,jdbcType=DATE}");
        sql.SET("reg_time = #{record.regTime,jdbcType=TIMESTAMP}");
        sql.SET("gold = #{record.gold,jdbcType=INTEGER}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("open_id = #{record.openId,jdbcType=VARCHAR}");
        sql.SET("open_id_h5 = #{record.openIdH5,jdbcType=VARCHAR}");
        sql.SET("union_id = #{record.unionId,jdbcType=VARCHAR}");
        sql.SET("union_open_id = #{record.unionOpenId,jdbcType=VARCHAR}");
        sql.SET("union_union_id = #{record.unionUnionId,jdbcType=VARCHAR}");
        sql.SET("is_agent = #{record.isAgent,jdbcType=BIT}");
        sql.SET("info_complete_status = #{record.infoCompleteStatus,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        
        HighUserExample example = (HighUserExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighUser record) {
        SQL sql = new SQL();
        sql.UPDATE("high_user");
        
        if (record.getHeaderImg() != null) {
            sql.SET("header_img = #{headerImg,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{name,jdbcType=VARCHAR}");
        }
        
        if (record.getPhone() != null) {
            sql.SET("phone = #{phone,jdbcType=VARCHAR}");
        }
        
        if (record.getPassword() != null) {
            sql.SET("`password` = #{password,jdbcType=VARCHAR}");
        }
        
        if (record.getSex() != null) {
            sql.SET("sex = #{sex,jdbcType=VARCHAR}");
        }
        
        if (record.getBirthdate() != null) {
            sql.SET("birthdate = #{birthdate,jdbcType=DATE}");
        }
        
        if (record.getRegTime() != null) {
            sql.SET("reg_time = #{regTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getGold() != null) {
            sql.SET("gold = #{gold,jdbcType=INTEGER}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpenId() != null) {
            sql.SET("open_id = #{openId,jdbcType=VARCHAR}");
        }
        
        if (record.getOpenIdH5() != null) {
            sql.SET("open_id_h5 = #{openIdH5,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionId() != null) {
            sql.SET("union_id = #{unionId,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionOpenId() != null) {
            sql.SET("union_open_id = #{unionOpenId,jdbcType=VARCHAR}");
        }
        
        if (record.getUnionUnionId() != null) {
            sql.SET("union_union_id = #{unionUnionId,jdbcType=VARCHAR}");
        }
        
        if (record.getIsAgent() != null) {
            sql.SET("is_agent = #{isAgent,jdbcType=BIT}");
        }
        
        if (record.getInfoCompleteStatus() != null) {
            sql.SET("info_complete_status = #{infoCompleteStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{ext4,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighUserExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}